diff -uNrd ircd-hybrid-6.2/README.FEF.NOW ircd-hyb6.2-FEFr5/README.FEF.NOW
--- ircd-hybrid-6.2/README.FEF.NOW	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.2-FEFr5/README.FEF.NOW	Sun Sep 30 20:28:50 2001
@@ -0,0 +1,282 @@
+==================
+=Revision History=
+==================
+!!! = Changed
++++ = Added
+--- = Removed
+
+FEFr1: (Runt)
+!!! The length of nicks allowed changed from 9 to 15.
+!!! Each channel is now allowed 50 bans, instead of 25.
+!!! The default config.h value for the max. channels per user is now 20.
++++ Banned users cannot talk. (UnderNet bquiet patch)
+
+FEFr2: (Runt)
+!!! Nothing changed in the hybrid-5 release of FEFr2.
+
+FEFr3: (Jail Bird)
++++ Added/Enhanced DalNet U:'s added
+!!! TOPIC lengths changed from 80 bytes to 255.
+
+FEFr4wb5 (wide-beta 5): (Runt/Jail Bird)
++++ WHOIS_SIGNON_TIME; shows when a user signed on in /whois. (Runt)
++++ OPERS_SEE_INVISIBLE; allows opers to see +i users. (Runt)
++++ OPERS_SEE_PRIV; allows opers to see +s/+p chans. (Runt)
++++ DalNet Q:'s added. (Jail bird)
++++ STOPIC; TS-synched channel TOPICs. (Jail Bird)
++++ RESTART_ON_SIGSEGV; the server will now restart if it dies. (Jail Bird)
+!!! U-lined servers can now send to channels, regardless of modes. (Jail Bird)
+
+Changes made from +th FEFr4wb5 to +hybrid-5 FEFr4wb5: (Jail Bird)
++++ HYBRID_ONLY; allow links from +hybrid servers only.
++++ NETNAME; Set the name of the network in the welcome message.
+
+FEFr4: (Jail Bird)
++++ IDENTD_ONLY; Reject any users not running identd if the I: line calls
+    for it. (Taken from +CSr30)
++++ NO_RED_MODES; Reject any duplicate channel modes. (Taken from +CSr30)
++++ IDLE_CHECK; Reject any idle clients. (Taken from +CSr30)
++++ CHECK_CLONE; Reject any clonebots. (Taken from ircu)
++++ REMOTE_WHOIS; Shows if a remote user /wii's you, while OPERd.
++++ KLINE_CLONES; Will automatically K: line any clonebotters.
+
+Changes made from +th FEFr4 to +hybrid-5 FEFr4: (Jail Bird)
+!!! Replaced the +CSr25 CLONE_CHECK code with the UnderNet CHECK_CLONE code.
+!!! Reinstated the *@* I: code.  PLEASE USE *@* IN YOUR I: LINES!
+
+FEFr4.1: (Jail Bird) (Nothing really added, so we just added .1 :) )
+!!! Upgraded the base code from +hybrid-5 to +hybrid-5.3
+    See README.hybrid for those changes.
+--- ANTI_IP_SPOOF was broke in hyb5.3. DON'T USE!
+!!! Fixed buffer overrun in m_stopic.
+!!! Moved RES_SRC to main Makefile.
+!!! Fixed WHOIS_SIGNON_TIME code.
+!!! Cleaned up all gcc warnings.
++++ Added fixes from FEFr4-withfixes.
+!!! Optimized for FEFnet.
+
+FEFr4.2 (Jail Bird) (bug fixes galore!)
+!!! Updated base code to hybrid-5.3p2
++++ Added NULL checking in m_stopic() to prevent malicious server attacks.
++++ Readded the varargs code, yet changed it to the ANSIfied 'stdargs' in the
+    process. Stdargs is now required, which shouldn't be a problem.
+!!! Replaced the EFnet ircsprintf.c with UnderNet's. It's faster and more
+    flexible.
+!!! Fixed Taner's ugly oper UMODES code.
+!!! Fixed problem with ircd overflowing when looking up access for long hosts.
+!!! Reverted I: lines to our old th-style lines. The server will now ALWAYS
+    check identd, but will only complain/reject if you have a '@' in the I:
+    lines (aka *@*).  This means you can allow non-identd users by adding a
+    I: line for them without the @.  ALL DEFAULT I: LINES SHOULD USE '*@*'!
+--- Removed FOLLOW_IDENT_RFC because of above change.  identd is always checked
+    now.
+--- Removed DO_IDENTD for the same reason. :)
++++ Added NO_REMOTE_INFO to disable INFO requests by remote clients. This helps
+    stop remote clients from splitting servers by flooding remote servers with
+    INFO requests.
+--- Removed the code in channel.c that blasted the TS on a channel when a non-U:
+    server sent a +o MODE.  This is unneeded as the only non-TS servers on our
+    nets are services, which are U:'d. Only a rogue server should ever do this,
+    and if it does, the hacker did a bad job in coding it :).
+!!! Fixed anti-DNS spoofing /whois code (aka the IP in /whois).
+!!! Changed m_topic so users can see topics on non-secret channels even if
+    they're not in the channel (they can already see it in /list!)
++++ Added OPERS_SEE_TOPIC, which lets Opers see the topics in any channel.
+--- Removed OPERWALL command. It's unneeded and was requested by Dianora :).
+--- Removed KLINE_CLONES option. It simply does NOT work with the UnderNet
+    clone code that we use.  This is a job for the tcm anyways.
+--- Removed NO_RED_MODES. This "feature" could cause channels to become
+    desynched.
+
+FEFr4.3 (Jail Bird) (watch the bloatware continue!)
++++ Readded SHOW_QUIT - Shows the client's quit reason.
++++ identd-replies of '~' are not longer considered valid.
++++ The code will now compile cleanly on an Alpha.
+!!! Updated base code to hybrid-5.3p4
+--- Removed NO_REMOTE_INFO, obseleted by 5.3p4
+
+FEFr4.3a (Jail Bird) (oops!)
+!!! hybrid-5.3p4 redid m_topic(), which killed our U: code.
+
+FEFr4.4 (Jail Bird)
+!!! Fixed proc_answer() code in res.c so that it is now portable.
+!!! Cleaned-up m_stopic()
+!!! Fixed ANTI_IP_SPOOF
++++ Readded AWAY propogation
+!!! Added NO_OPER_FLOOD code to the flud code
+!!! Upgraded base code to hybrid-5.3p6
+!!! Fixed bug in configure script that prevented it from detecting
+    what kind of non-blocking code to use on Linux glibc2 systems.
+    This caused a blocking version to be built, which caused "lockups".
+
+FEFr4.5 (Jail Bird)
+!!! Updated base code to hybrid-5.3p7.
++++ Added MacOSX compatibility patch by cybin.
+!!! Changed ANTI_IP_SPOOF PING to an unsigned (positive) number.
+!!! Fixed problem with the stdargs vsendto_one() function sending 550-byte
+    packets.
+!!! Updated blalloc.c.
+!!! Renamed existing doc/example.conf to doc/example.conf.bill and wrote
+    a new simplistic doc/exmaple.conf.
+!!! Fixed configure script to automatically setup CC/CFLAGS/IRCDLIBS.  This
+    should fix the "-lcrypt -lresolv" crap.
++++ 'make install' now copies the 'start' script to your SPATH.
+
+FEFr4.5a (Jail Bird)
+!!! Reverted the ANTI_IP_SPOOF PINGs back to signed due to atoi().
+
+FEFr4.6
++++ Readded the old inu+JB patch.
+
+FDFr1
+!!! Upgrade base code to hybrid-6.0
+!!! Changed name of ircd from +FEF to +FDF, since Runt and I are both
+    on FDFnet now.
+!!! VERY IMPORTANT: U: lines are now S: lines!!!
++++ Added FDF_ONLY: Allows connections only from other FDFr5b1 servers.
++++ Added SNICK Support: Services can now force nick changes.
++++ Added DalNet's +c channel mode. Channels that are +c'd will not allow
+    mIRC color or ANSI color to be sent to them.
+--- Removed K_LINES_OPER_ONLY. hybrid-6 will now show non-ops any K:
+    lines that match their hostmask.  This is better.
+!!! The server was ignoring MODE changes from servers, which was breaking
+    INU_SERV_CAN_OP. Fixed.
++++ Added support for JB_SERV_CAN_KICK.
++++ Added +FDF config.h settings to /info reply.
+!!! Fixed autoconf so that it defaults to building a stripped binary.
++++ Readded the UnderNet bquiet patch.
+!!! Fixed identd bug from hybrid-6 code change.
+!!! Fixed OPERS_SEE_INVISIBLE code when doing a /list. This was due
+    to cloning of code in hybrid-6's m_list().
+!!! Fixed the anti-DNS spoofing code (aka IP in /whois). Also changed it
+    so that only IRCops can see the IP. This works better with I-line
+    spoofing.
+!!! Fixed the HACK mesage when people use INU_IGNORE_BANS.
+!!! Fixed REMOTE_WHOIS
++++ If a user doesn't have identd and a '-' in their I: line, then the server
+    will send a NOTICE explaining why they have a '~' in their username.
+!!! Moved opers.txt into the DPATH so that /quote help will work.
+!!! Bumped MAX_BUFFERS down to 10 from 60.
+!!! Changed default config to NO_JOIN_ON_SPLIT_SIMPLE instead of
+    NO_OPS_ON_SPLIT. Hopefully not letting people JOIN channels on
+    split servers will remove the reason to DoS servers.
+--- Removed code to allow people to netsplit hack ops on channels
+    that do not have ops. This is to reduce DoS value.
++++ Added irc.best.net patch to show port numbers in unauthorized client
+    connection messages.
+!!! Hub servers should read the "Important" section below.
++++ Added INFO_OPER_ONLY in order to only allow /info requests from
+    IRC Ops.
+!!! Changed GLINE code so that only 2 opers are required, not 3.
+!!! Changed GLINE code so that GLINEs from S: lined servers are added
+    immediately.
+!!! Disabled DEBUG mode, which should speed-up the server.
+!!! Offical configure command-line for gcc users (using sh,ksh,bash):
+    CC="gcc" CFLAGS="-O6 -fomit-frame-pointer -pipe -w -s" LDFLAGS="-s" \
+    ./configure
+!!! Fixed AlcServ/ErisServ by readding IRCII_KLUDGE code
+!!! Fixed bug were remote nicknames trying to introduce servers would core
+    the server.
++++ IDLE_RESET - Lets you /quote IDLE to set your idle time. -Runt
+--- Removed SHOW_QUIT. This has been superceeded by WINTRHAWK
+
+FEFr5
+!!! Upgraded base code to hybrid-6.2
+--- Removed NETNAME, replaced by hybrid's NETWORK_NAME
+--- Removed HYBRID_ONLY, hybrid-6.2 is effectivly 'HYBRID_ONLY'
+!!! Changed name of server back to +FEF
+!!! Changed FDF_ONLY to FEF_ONLY. The code still passes 'FDF' however, so that
+    it will be backwards compatible.
+!!! Cleaned-up #ifdef's so that the code will compile with gcc 3.0.1
+
+===========
+=Important=
+===========
+
+If you are compiling a *HUB SERVER*
+
+MAKE SURE YOU CHANGE THE SPLIT SETTINGS IN YOUR CONFIG.H!
+
+SPLIT_SMALLNET_SIZE should be roughly the number of servers on your network,
+minus a couple as a buffer.
+
+SPLIT_SMALLNET_USER_SIZE should be the LOWEST number of users seem at any
+given time on the network, minus about 10-20 or so as a buffer.
+
+==========
+=Problems=
+==========
+
+Problem #1: Getting "res_" errors during linking.
+Fixes: 1) Make sure "-lresolv" is in your IRCDLIBS= in the Makefile.
+       2) Install bind8.  Add "-I/path/to/bind8/include" to CFLAGS=,
+          and "-L/path/to/bind8/libs -lbind" in the IRCDLIBS=.
+
+Problem #2: The server gives a chdir error when ran.
+Fixes: 1) Real Fix: Edit the DPATH in the config.h
+       2) Temp Fix: Start ircd as "./ircd -d ."
+
+	I hope this helps...
+
+==================
+=Support Channels=
+==================
+
+On FDFnet: Join #FDFworld
+On FEFnet: Join #continuum
+
+=========
+=Authors=
+=========
+
+The authors of the +FDFr server are:
+
+    John "Runt" Leslie          - john@stf.org
+    Dustin "Jail Bird" Marquess - jailbird@alcatraz.fdf.net
+
+=========
+=Credits=
+=========
+
+We would like to thank the original ircd team for their work.  We would also
+like to thank digital, Taner Halicioglu, and the Hybrid team for their work
+on the base code. Out of the Hybrid team, special thanks goes to Dianora, who
+helped us, even though she didn't have to.
+
+Thanks go out to Steve "inubus" White for supplying us with code.
+
+Also thanks to Ryan Kubica on FEFnet for writing services and exploiting our
+S: code to make it work :).
+
+==============
+=Distribution=
+==============
+
+The FDFnet ircd is officially available via FTP from the following locations:
+
+ftp://ftp.fdf.net/pub/irc/
+ftp://ftp.fef.net/pub/irc/
+
+It is also usually mirrored at:
+
+ftp://ftp.liii.com/pub/unix/irc/
+ftp://ftp.bitchx.org/pub/servers/
+
+
+You can also obtain the newest code in development using CVS. Here at the
+steps needed to pull this off:
+
+1) Get cvs if you don't have it.
+2) cvs -d :pserver:cvs@bobdole.fdf.net:/cvs login  # Password is "cvs".
+3) cvs -d :pserver:cvs@bobdole.fdf.net:/cvs co ircd-FDF
+
+This will create a directory called "ircd-FDF" under the current directory that
+will contain the current source code.  To update the code in the future, run:
+
+        cvs update       (from the ircd-FDF dir)
+
+NOTE: The CVS tree is used for development of the ircd.  This code may be
+      unstable and buggy.  The good part about using this tree, is it's always
+      the newest code! :).
+
+					-Dustin "Jail Bird" Marquess
diff -uNrd ircd-hybrid-6.2/doc/ChangeLog.old ircd-hyb6.2-FEFr5/doc/ChangeLog.old
--- ircd-hybrid-6.2/doc/ChangeLog.old	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.2-FEFr5/doc/ChangeLog.old	Fri Mar 26 00:21:01 1999
@@ -0,0 +1,207 @@
++hybrid-5.3 (6/13/98)
+* added NO_CHANOPS_WHEN_SPLIT code back in (Rodder/Dianora)
+* fixed SEPARATE_QUOTE_KLINES_BY_DATE so it compiles (Rodder)
+* removed LITTLE_I_LINES from config.h for now (Rodder)
+* should compile on Linux/glibc now (Rodder)
+
++hybrid-5.2p1 (5/12/98)
+* removed uneeded variable in aClient (Dianora)
+* added missing #ifdef's for USE_SYSLOG (Dianora)
+* reverted to old check_pings() to fix high cpu usage (Rodder)
+* fixed DEBUGMODE (Dianora)
+
++hybrid-5.2 (4/21/98) - The inevitable bug fix release
+-fixes
+* changed many of the defaults in config.h
+* removed ident_fdlist it was never used anyway (comstud)
+* fixed quote kline for 10 character user names (Dianora)
+* obscure bug with KICK message in a desync channel situation (Dianora)
+* bug with max channel name fixed (comstud/Dianora)
+* stop spam from links command i.e. beeps (Dianora)
+* bug with default +i not showing MODE to user initially (Rodder)
+* ANTI_IP_SPOOF moved to "broken" section of conf (Rodder)
+* ident lookups now work properly for all interfaces of
+  multihomed (or "VIF"'d) machines, including Solaris 2.6 (Rodder)
+* stats l/L no longer shows -i clients to non-opers (Rodder)
+* exorcised evil timedelta variable
+* Fixed oper wallops broadcasting instead of routing (Dianora)
+* Covered up bogus "Got Ident" messages in read_authports() (Rodder)
+* Fixed missing RPL_ENDOFTRACE for non-opered clients (Dianora)
+* #undef IDLE_FROM_MSG fixed, ping/pong/ison do not reset idle time (Dianora)
+
+-feature adds
+* bumped HTM code to not kick in until 40K/s by default
+* stop people from laming up the kline conf file with # in comment (Dianora)
+* added comstuds SEPARATE_QUOTE_KLINES_BY_DATE
+* use block allocator in FLUD code (Shadowfax)
+* added HTM quiet or HTM noisy option -- see NOISY_HTM in config.h
+  for initial setting (Dianora)
+* added LOCOPS, each type of wallops/operwall/locops is now flagged (Dianora)
+* added signon time to RPL_WHOISIDLE (Dianora)
+* allow local opers to see kills requested by riss (Dianora)
+* added ANTI_SPAMBOT code, read config.h (Dianora)
+* added fixklines to tools dir, use it to check kline.conf for #'s inside
+  of K-line comments (Dianora)
+* added OLD_Y_LIMIT in config.h.dist to go back to old Y/I line behaviour
+  (Dianora)
+* M: line passwd field now used to specify address to bind to on
+  machines with multiple interfaces.  (Rodder)
+* P: line passwd field now used to specify address to bind to on  
+  machines with multiple interfaces. (Rodder)
+* added /quote set SPAMNUM SPAMTIME to control ANTI_SPAMBOT behaviour (Dianora)
+* hybrid option flags removed from m_version and replaced
+  by (for opers) full listing of server defines in m_info (Rodder)
+* poll() code mods ported from CSr30 (comstud) by cbongo
+* m_whois() rewritten to use hash table when possible (Dianora)
+* spambot sign on code added (ThemBones)
+* i line (LITTLE_I_LINE) support, restricted i lines (Dianora)
+* NO_CHANOPS_WHEN_SPLIT delays channel hacking until rejoin (Dianora)
+* ANTI_SPAMBOT on sign on code (ThemBones)
+* only allow 4 kicked nicks per kick (Dianora)
+* sped up kline processing, redid check_pings in ircd.c (Dianora) 
+* Server now checks for sane TS when connecting to other server,
+  see TS_MAX_DELTA and TS_WARN_DELTA in config.h (Rodder)
+* Server checks for backwards spinning clock and complains if
+  found (Rodder)
+* Check for error when timeofday is set (Shadowfax)
+* Announce TS changes after TS induced deops (Shadowfax)
+* stop redistributing away information to other servers
+* Prepared for TS4 mixed net by checking validity of channel mode changes
+  only at the local server (orabidoo)
+
++hybrid-5 (9/26/97)
+* LOTS AND LOTS OF CHANGES IN CONFIG.H
+* reorganized source tree, eliminating common subdir
+* reworked hash.c (Dianora)
+* reworked parse.c, tree prefix command lookups (Dianora/orabidoo)
+* all code is now function prototyped (Dianora)
+* improved bad host/nick handling, i.e. dns spoofers (ThemBones)
+* sped up send_umode_out in s_user.c (ThemBones)
+* sped up whowas processing, removed away from whowas (Dianora)
+* redid m_kline/cluster in s_serv.c (Dianora)
+* redid dline/kline handling (Dianora/Rodder/ThemBones)
+* removed lame #ifdefs in poll() (Dianora)
+* always defined D_LINES/E_LINES/F_LINES (Dianora)
+* TS_ONLY server now (Dianora) 
+* cleaned up s_auth.c (Dianora/ThemBones)
+* changed BAN_INFO handling (Dianora)
+* sanity testing in res.c (Dianora)
+* added orabidoo's scache code (orabidoo/Dianora)
+* added KLINE_WITH_REASON kline reason on klines/connects (Dianora)
+* added NON_REDUNDANT_KLINE code (Dianora)
+* added ANTI_IP_SPOOF code (Dianora)
+* added temporary kline code (Dianora)
+* added Jolo's block allocator into list.c (Jolo/Dianora)
+* added ANTI_NICK_FLOOD code (Dianora) 
+* removed UNIXPORT code (Dianora)
+* removed lame unused code in match.c (Jolo)
+* corrected many type errors, ran through purify (Jolo)
+* removed unused variables (Dianora)
+* folded in Shadowfax's FLUD code (Shadowfax/Dianora)
+* folded in Shadowfax's LOCKFILE code (Shadowfax/Dianora/Rodder/ThemBones)
+* added optional GLINE code (Dianora)
+* stats K now works for normal users (Dianora)
+* quote UNKLINE code as a option added (Dianora/common)
+* Reworked ACKPATCH, removed ONE kludge and use confeq field of Y instead,
+  used hash table of ip's (Dianora)
+* removed UNIXPORT support (Dianora)
+* added support for oper WALLOPS back in.  Use /quote OPERWALL to send operwalls.
+* reworked version.c.SH to track build number (Rodder)
+* make clean removes more junk (Rodder)
+* added check for adequate FD_SETSIZE
+* created tools subdir (Rodder)
+* added "Unauthorized connection" back in, under umode +c (Dianora/Rodder)
+* modified autoconf for Solaris 2.6 (Rodder)
+* modified LUSERS to ignore masks (Rodder)
+* fixed mysterious exit() in fdlist.c from fd leak in s_auth.c (Dianorans)
+* fixed overrun bugs in res.c (Dianora/Johan/Shadowfax)
+
+-----------------------------------------------------------------------------
++hybrid-4.3 (8/19/97) - more bug fixes
+* typo that caused immediate crash on HPUX fixed
+* IP/hostname mismatch code fixed, warns the user instead of opers
+* typo fixed in missing klinefile error message
+
++hybrid-4.2 (8/4/97) - minor bug fix, one new feature
+* rcs version string was clobbering server version string
+* Bans can now match by IP for hosts that resolv (db)
+  IP_BAN_ALL define added to config.h
+
++hybrid-4 (7/28/97)
+* LOTS OF NEW STUFF IN CONFIG.H, GO READ IT!!  THE WHOLE THING!!
+  EVEN IF YOU ARE UPGRADING TO THIS FROM A HYBRID-4 BETA!!
+* patch for yet another NICK bug
+* patch for m_server() bug
+* patch for TS3 bug
+* switched to GNU autoconf (thanks ns!)
+* WALLOPS now only go to real opers
+* ircsprintf() mod to check for NULL args (db)
+* fixed possible overflow res.c (db)
+# seperate klines file  - see config.h (db)
+* quote_dline support - see config.h (db)
+* fixed timezone snafu in date()
+* added RFC1035_ANAL define reject _ and / in hostnames
+* removed old DELAY_NICK define..  broken and unneeded
+* modified s_err.c and created s_err.h.  See CUSTOM_ERR in include/config.h
+* m_server() now quietly ignores clients that try to use SERVER
+* removed NOTE code, removed SUMMON code, gutted USERS
+* added automatic timestamps to comments of quote KLINE and DLINE
+* changed failure notice for clients bouncing off ACKPATCH
+  to "Only one connection at a time allowed from your hostname"
+* cleanup to channel.c
+* format() mod to check for NULL args (di)
+* removed more useless crap (UPHOST, VMS, etc) from config.h
+* #undef F_LINES fixed
+* oper WALLOPS changed to OPERWALL (code taken from csr30)
+* BSDI 3.0 FD_ALLOC support (db)
+# changed output of STATS D
+* Removed Q: line support
+* cleaned up find_conf_ip (db)
+* fixed crypt() usage to work on systems with longer salts
+  (ie FreeBSD without DES libs)
+* various spelling fixes (db)
+* N: line checking in m_server() (db)
+* WARN_NO_NLINE define added to config.h
+
+-----------------------------------------------------------------------------
++hybrid-3 (6/17/97):
+* Added USRIP command.  This command returns user@ip in a USERHOST
+  reply for local clients only.  Requests for remote nicks are treated
+  as though the nick doesn't exist.
+* Switched to Dianora's faster dich_conf.c
+* Check for invalid characters (see RFC1035) in hostnames
+* Fixed problem with coring due to invalid hostnames on non-local users
+* TSora version 3
+* Turned D_LINE support back on
+* Numerous changes to Config script, may actually work now
+* Additional OS defs in Makefile
+* Minor cleanup in include/config.h
+# created new INSTALL document
+
+-----------------------------------------------------------------------------
++hybrid-2 (4/12/97):
+This is ircd2.8/th.v5a.3 with the WHO, WHOWAS, and IsMember() code
+from Comstud's irc2.8.21CSr29.  Please send email to Jon Lusky
+<lusky@vol.com> if you find problems with it.
+
+Relevant excerpt from irc2.8.21+CSr29/README.CS:
+3) /whowas code totally rewritten.  This code is better than Avalon's
+   ever was.  You can now raise NICKNAMEHISTORYLENGTH in config.h to
+   a value that makes sense with today's number of clients.  Without
+   rewriting, you could expect server lockup, mostly during splits.
+   These changes should lower CPU usage quite a bit, especially during
+   splits.
+4) /who code tweaked.  IsMember() = CPU hog...IsMember() has been changed
+   and m_who does less find_user_link()s now...much less.  This is
+   a big reducer of CPU usage.  Also another "bug" was removed from
+   m_who that can possibly cause server lockups.  The possibility still
+   remains, though...not sure how to improve it further without totally
+   breaking /who.
+5) This goes with #4, but...
+   /who nickname was optimized tremendously.  However, this breaks /who
+   if you do /who username and username happens to match a nickname.
+   Oh well...too bad.
+
+-----------------------------------------------------------------------------
++hybrid-1 never really existed
+
diff -uNrd ircd-hybrid-6.2/doc/example.conf ircd-hyb6.2-FEFr5/doc/example.conf
--- ircd-hybrid-6.2/doc/example.conf	Tue Jul 10 08:40:24 2001
+++ ircd-hyb6.2-FEFr5/doc/example.conf	Mon Aug 20 23:32:30 2001
@@ -189,6 +189,8 @@
 ##
 ## < This user is exempt from idle restrictions if IDLE_CHECK is defined
 ##
+## < This user is exempt from idle restrictions if IDLE_CHECK is defined
+##
 
 ## Examples
 ## c) I:NOMATCH::^db@koruna.varner.com::3
diff -uNrd ircd-hybrid-6.2/include/channel.h ircd-hyb6.2-FEFr5/include/channel.h
--- ircd-hybrid-6.2/include/channel.h	Tue Jul 17 22:15:18 2001
+++ ircd-hyb6.2-FEFr5/include/channel.h	Mon Aug 20 23:35:02 2001
@@ -55,10 +55,8 @@
   struct Channel* hnextch;
   struct Mode     mode;
   char            topic[TOPICLEN + 1];
-#ifdef TOPIC_INFO
   char            topic_nick[NICKLEN + 1];
   time_t          topic_time;
-#endif
   int             users;
   struct SLink*   members;
   struct SLink*   invites;
@@ -110,6 +108,7 @@
 extern void    channel_modes(struct Client *, char *, char *, struct Channel*);
 extern void    set_channel_mode(struct Client *, struct Client *, 
                                 struct Channel *, int, char **);
+int msg_has_colors(char *);
 
 
 
@@ -151,9 +150,9 @@
 
 #define MODE_LIMIT      0x2000  /* was 0x1000 */
 #define MODE_FLAGS      0x2fff  /* was 0x1fff */
+#define MODE_NOCOLOR	0x4000
 #ifdef NEED_SPLITCODE
 
-
 extern int server_was_split;
 extern time_t server_split_time;
 
@@ -190,7 +189,11 @@
 /* channel not shown but names are */
 #define HiddenChannel(x)        ((x) && ((x)->mode.mode & MODE_PRIVATE))
 /* channel visible */
-#define ShowChannel(v,c)        (PubChannel(c) || IsMember((v),(c)))
+#ifdef OPERS_SEE_PRIV
+# define ShowChannel(v,c)	(PubChannel(c) || IsMember((v),(c)) || IsAnOper(v))
+#else
+# define ShowChannel(v,c)        (PubChannel(c) || IsMember((v),(c)))
+#endif /* OPERS_SEE_PRIV */
 #define PubChannel(x)           ((!x) || ((x)->mode.mode &\
                                  (MODE_PRIVATE | MODE_SECRET)) == 0)
 
diff -uNrd ircd-hybrid-6.2/include/client.h ircd-hyb6.2-FEFr5/include/client.h
--- ircd-hybrid-6.2/include/client.h	Fri Aug 10 04:02:28 2001
+++ ircd-hyb6.2-FEFr5/include/client.h	Mon Aug 20 23:37:08 2001
@@ -241,6 +241,9 @@
   time_t            last_nick_change;
   int               number_of_nick_changes;
 #endif
+#ifdef ANTI_IP_SPOOF
+  unsigned int	random_ping;	/* spoofers won't see this */
+#endif
   time_t            last_knock; /* don't allow knock to flood */
   /*
    * client->sockhost contains the ip address gotten from the socket as a
@@ -301,9 +304,9 @@
 #endif
 
 #ifdef TS5_ONLY
-#define TS_MIN   	5
+#define TS_MIN	5
 #else
-#define TS_MIN          3       /* minimum supported TS protocol version */
+#define TS_MIN	3	/* minimum supported TS protocol version */
 #endif
 
 #define TS_DOESTS       0x20000000
@@ -347,6 +350,9 @@
 /* *sigh* overflow flags */
 #define FLAGS2_RESTRICTED   0x0001      /* restricted client */
 #define FLAGS2_PING_TIMEOUT 0x0002
+#ifdef ANTI_IP_SPOOF
+# define FLAGS2_GOT_ANTI_SPOOF_PING	0x2000
+#endif
 #define FLAGS2_E_LINED      0x0004      /* client is graced with E line */
 #define FLAGS2_B_LINED      0x0008      /* client is graced with B line */
 #define FLAGS2_F_LINED      0x0010      /* client is graced with F line */
@@ -384,7 +390,6 @@
 #define FLAGS2_IP_HIDDEN        0x200000        /* client IP should be hidden
                                                    from non opers */
 #define FLAGS2_SENDQ_POP  0x400000  /* sendq exceeded (during list) */
-
 
 #define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP)
 #define ALL_UMODES   (SEND_UMODES | FLAGS_SERVNOTICE | FLAGS_CCONN | \
